SegaScreen:
		move.b	#Snd_Special_StopSng,d0
		bsr.w	PlaySound_Special	;Stop ALL Music/SFX
		bsr.w	ClearPLC		;Clear PLC
		bsr.w	Pal_FadeFrom

		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C81,(a6)

		clr.b	(RAM_FillWaterPalScr).w

		move	#$2700,sr
		move.w	(RAM_VDP_SavedCmd81).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		bsr.w	ClearScreen

		move.l	#$40000000,($C00004).l		;Compressed Art [Nem]: "SEGA"/"TM"
		lea	(Nem_SegaLogo).l,a0
		bsr.w	NemDec

		lea	(RAM_MetablockTable).l,a1	;Uncompressed data -> RAM_MetablockTable
		lea	(Eni_SegaLogo).l,a0		;Compressed data
		move.w	#0,d0
		bsr.w	EniDec
		lea	(RAM_MetablockTable).l,a1	;Read mappings data from RAM_MetablockTable
		move.l	#$65100003,d0			;VDP Location
		moveq	#$17,d1				;X-pos
		moveq	#7,d2				;Y-pos
		bsr.w	LoadMaps

		lea	(RAM_MetablockTable+$180).l,a1		;(Hard-Coded)
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		bsr.w	LoadMaps

		tst.b	(RAM_MD_SysRegion).w
		bmi.s	SegaScreen_LeaveTM

		lea	(RAM_MetablockTable+$A40).l,a1		;Delete "TM"
		move.l	#$453A0003,d0
		moveq	#2,d1
		moveq	#1,d2
		bsr.w	LoadMaps

SegaScreen_LeaveTM:
		moveq	#0,d0
		bsr.w	PalLoad2

		move.w	#$FFF6,(RAM_PalCyc_Timer1).w
		move.w	#0,(RAM_PalCyc_Timer2).w
		move.w	#0,($FFFFF662).w
		move.w	#0,($FFFFF660).w

		move.w	(RAM_VDP_SavedCmd81).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l

Sega_WaitPalette:
		move.b	#2,(RAM_VIntCount).w
		bsr.w	DelayProgram

		bsr.w	PalCycle_Sega
		bne.s	Sega_WaitPalette

		move.b	#$E1,d0
		bsr.w	PlaySound_Special

		move.b	#$14,(RAM_VIntCount).w
		bsr.w	DelayProgram
		move.w	#$1E,(RAM_DemoTimeLeft).w

Sega_WaitEnd:
		move.b	#2,(RAM_VIntCount).w
		bsr.w	DelayProgram

		tst.w	(RAM_DemoTimeLeft).w
		beq.s	Sega_GoToTitleScreen
		andi.b	#$80,(RAM_Control_1_Press).w
		beq.s	Sega_WaitEnd

Sega_GoToTitleScreen:
		move.b	#4,(RAM_GameMode).w
		rts