;----------------------------------------------------------------
; Variable				=		RAM		Is:

RAM_DynResizeCntr			equ		$FFFFEEDF	;Byte
RAM_GameMode				equ		$FFFFF600       ;Byte
RAM_VIntCount				equ		$FFFFF62A       ;Byte
RAM_FillWaterPalScr			equ		$FFFFF64E       ;Byte
RAM_ErrorCode				equ		$FFFFFC44	;Byte
RAM_Level_CurrentZone			equ		$FFFFFE10	;Byte
RAM_Level_CurrentAct			equ		$FFFFFE11	;Byte
RAM_MD_SysRegion			equ		$FFFFFFF8	;Byte
RAM_DebugMode_SelObj			equ		$FFFFFE06	;Byte
RAM_DebugMode_WaitToMove		equ		$FFFFFE0A	;Byte
RAM_DebugMode_MoveSpeed			equ		$FFFFFE0B	;Byte
RAM_Sonic_Lives				equ		$FFFFFE12 	;Byte
RAM_SpecialStg_Level			equ		$FFFFFE16	;Byte
RAM_Sonic_Continues			equ		$FFFFFE18	;Byte

RAM_Control_1_Hold_Copy			equ		$FFFFF602	;Byte
RAM_Control_1_Press_Copy		equ		$FFFFF603	;Byte
RAM_Control_1_Hold			equ		$FFFFF604	;Byte
RAM_Control_1_Press			equ		$FFFFF605	;Byte
RAM_Control_2_Hold			equ		$FFFFF606	;Byte
RAM_Control_2_Press			equ		$FFFFF607	;Byte

RAM_SndDrv_TstSFX			equ		$FFFFFFE1	;Byte
RAM_SndDrv_PlaySnd			equ		$FFFFFFE3	;Byte
RAM_SndDrv_PlaySnd_2			equ		$FFFFFFE4	;Byte

RAM_S1_CreditsID			equ		$FFFFFFF4	;Byte

RAM_Sonic_Emeralds			equ		$FFFFFE57	;Byte

RAM_Level_WaterRoutineCntr		equ		$FFFFF64D	;Byte

RAM_Level_LamppostCntr			equ		$FFFFFE30	;Byte

RAM_Sonic_1upScore			equ		$FFFFFE1B	;Byte

RAM_Pal_FadeToCtrl_PalStart		equ		$FFFFF626	;Byte
RAM_Pal_FadeToCtrl_PalLength		equ		$FFFFF627	;Byte

RAM_Level_Pause_Unk			equ		$FFFFF003	;Byte

RAM_ObjSpecial_RingFrame_1		equ		$FFFFFEC0	;Byte
RAM_ObjSpecial_RingFrame_2		equ		$FFFFFEC1	;Byte
RAM_ObjSpecial_RingFrame_3		equ		$FFFFFEC2	;Byte
RAM_ObjSpecial_RingFrame_4		equ		$FFFFFEC3	;Byte
RAM_ObjSpecial_RingFrame_5		equ		$FFFFFEC4	;Byte
RAM_ObjSpecial_RingFrame_6		equ		$FFFFFEC5	;Byte
RAM_ObjSpecial_RingFrame_7		equ		$FFFFFEC6	;Byte
RAM_ObjSpecial_RingFrame_8		equ		$FFFFFEC7	;Byte
RAM_ObjSpecial_RingFrame_9		equ		$FFFFFEC8	;Byte

RAM_Lamppost_LamppostCntr		equ		$FFFFFE31	;Byte
RAM_Lamppost_Sonic_1upScore		equ		$FFFFFE54	;Byte
RAM_Lamppost_Hud_Time			equ		$FFFFFE38	;Long
RAM_Lamppost_DynResizeCntr		equ		$FFFFFE3C	;Byte
RAM_Lamppost_Level_YPos_SetEnd		equ		$FFFFFE3E	;Byte

RAM_Lamppost_FillWtrPalScr		equ		$FFFFFE53	;Byte
RAM_Level_BossMode			equ		$FFFFF7AA	;Byte

RAM_ObjPos_SubCntr			equ		$FFFFF76C

RAM_LevelSys_Unk			equ		$FFFFEE40
RAM_LevelSys_Ver_Flag_Unk		equ		$FFFFEEDE

RAM_RingSys_Routine			equ		$FFFFF710	;Byte

RAM_Debug_MaxSprites			equ		$FFFFF62C	;Byte

RAM_LevelSys_DirToDraw			equ		$FFFFEE50	;Byte
RAM_LevelSys_DirToDraw_2p		equ		$FFFFEE58	;Byte
RAM_LevelSys_DirToDraw_Backup		equ		$FFFFEEA0	;Byte

RAM_Sonic_CurrAngle_Front		equ		$FFFFF768
RAM_Sonic_CurrAngle_Below		equ		$FFFFF76A

RAM_Flag_Sonic_IgnoreControl		equ		$FFFFF7CC	;Byte
RAM_Sonic_IgnoreCtrl_2			equ		$FFFFF7CA	;Byte

RAM_TailsCPU_Random			equ		$FFFFEED3	;Byte

RAM_Vint_Unk				equ		$FFFFF628	;Byte

; ------------------------------------------------------------------------

RAM_DemoTimeLeft			equ		$FFFFF614	;Word
RAM_Sonic_TopSpeed			equ		$FFFFF760	;Word
RAM_Sonic_Acceleration			equ		$FFFFF762	;Word
RAM_Sonic_Deceleration			equ		$FFFFF764	;Word
RAM_Level_CurrentZone			equ		$FFFFFE10	;Word

RAM_LevelSys_XPos_SetEnd		equ		$FFFFEECA	;Word
RAM_LevelSys_YPos_SetStart		equ		$FFFFEECC	;Word
RAM_LevelSys_YPos_SetEnd		equ		$FFFFEECE	;Word

RAM_LevelSys_Buff			equ		$FFFFEE00
RAM_LevelSys_Buff_Backup		equ		$FFFFEE60
RAM_LevelSys_Buff_2p			equ		$FFFFEE20
RAM_LevelSys_Buff_2p_Backup		equ		$FFFFEE80

RAM_Lamppost_LevelSysBuf		equ		$FFFFFE40

RAM_LevelSys_VerUpdBuff			equ		$FFFFEF00

RAM_Level_Xpos				equ		$FFFFEE00	;Word
RAM_Level_Camera_YPos_Start		equ		$FFFFEE04	;Word
RAM_Level_XPos_2P			equ		$FFFFEE20	;Word
RAM_Level_Camera_YPos_Start_2P		equ		$FFFFEE24	;Word


RAM_PLC_TilesLeft_Piece			equ		$FFFFF6F8 	;Word
RAM_PLC_TilesLeft_Frame			equ		$FFFFF6FA 	;Word

RAM_VDPCmdForHInt			equ		$FFFFF624 	;Word

RAM_PalCyc_Timer1			equ		$FFFFF632	;Word
RAM_PalCyc_Timer2			equ		$FFFFF634	;Word
RAM_PalCyc_Timer3			equ		$FFFFF654	;Word

RAM_Level_WaterSpd			equ		$FFFFF652	;Word

RAM_LevSel_SelItem			equ		$FFFFFF82	;Word
RAM_LevSel_SelSnd			equ		$FFFFFF84	;Word

RAM_Sonic_CurrentRings			equ		$FFFFFE20	;Word
RAM_LevSel_CursorPos			equ		$FFFFFF80	;Word
RAM_Demo_DemoLevelCnt			equ		$FFFFFFF2	;Word

RAM_TailsCPU_Timer			equ		$FFFFF702	;Word

RAM_Level_Water_Action			equ		$FFFFF646	;Word
RAM_Level_Water_MainPos			equ		$FFFFF648	;Word
RAM_Level_Water_SetPos			equ		$FFFFF64A	;Word

RAM_Sonic_AirLeft			equ		$FFFFFE14	;Word
RAM_Demo_ButtonIndex_2P			equ		$FFFFF740	;Word
RAM_Demo_ButtonIndex			equ		$FFFFF790	;Word

RAM_Sonic_StaticsRecBuffer		equ		$FFFFEED2	;Word

RAM_Sonic_TopSpeed			equ		$FFFFF760	;Word
RAM_Sonic_Acceleration			equ		$FFFFF762	;Word
RAM_Sonic_Deceleration			equ		$FFFFF764	;Word

RAM_VDP_VScroll				equ		$FFFFF616	;Word
RAM_VDP_VScroll_2p			equ		$FFFFEEF0	;Word
RAM_DMA_DataChunk			equ		$FFFFF640	;Word
RAM_VDP_Command_1			equ		$FFFFF60C	;Word

RAM_Level_Camera_Boundary_1		equ		$FFFFEEC6	;Word

RAM_SS_Unknown_1			equ		$FFFFF794	;Word

RAM_VDP_SavedCmd81			equ		$FFFFF60C	;Word

RAM_Level_GetYPos_80			equ		$FFFFF7D8
RAM_ObjPos_DelSpr			equ		$FFFFF7DA
RAM_ObjPos_DelSpr_2p			equ		$FFFFF7DC

RAM_Level_Bonus_Time			equ		$FFFFF7D2	;Word
RAM_Level_Bonus_Rings			equ		$FFFFF7D4	;Word

RAM_LevelSys_WaitToScr			equ		$FFFFEED0
RAM_LevelSys_WaitToScr_2p		equ		$FFFFEED4

RAM_LevelSys_DrawSpeed_XPos		equ		$FFFFEEB0	;Word
RAM_LevelSys_DrawSpeed_YPos		equ		$FFFFEEB2	;Word
RAM_LevelSys_DrawSpeed_2p_XPos		equ		$FFFFEEB6	;Word
RAM_LevelSys_DrawSpeed_2p_YPos		equ		$FFFFEEB8	;Word

RAM_LevelSys_ForceToYPos		equ		$FFFFEED8	;Word
RAM_Deform_Unk_1			equ		$FFFFF620

RAM_Lamppost_Sonic_XPos			equ		$FFFFFE32	;Word
RAM_Lamppost_Sonic_YPos			equ		$FFFFFE34	;Word
RAM_Lamppost_Sonic_CurrRings		equ		$FFFFFE36	;Word
RAM_Lamppost_Water_MainPos		equ		$FFFFFE50	;Word
RAM_Lamppost_Water_RoutineCntr		equ		$FFFFFE52	;Word

RAM_DebugMode_YPosSetStart		equ		$FFFFFEF0	;Word
RAM_DebugMode_CamaraBoundary1		equ		$FFFFFEF2	;Word

RAM_RingSys_Addr_1			equ		$FFFFF712	;Word
RAM_RingSys_Addr_2			equ		$FFFFF714	;Word
RAM_RingSys_Addr_1_2p			equ		$FFFFF716	;Word
RAM_RingSys_Addr_2_2p			equ		$FFFFF718	;Word

RAM_Level_Enemy_FixPoints		equ		$FFFFF7D0

RAM_Sonic_CurrAnimFrame			equ		$FFFFF766	;Word
RAM_Tails_CurrAnimFrame			equ		$FFFFF7DE	;Word

RAM_TailsTails_CurrAnimFrame		equ		$FFFFF7DF	;Word
RAM_TailsCPU_Routine			equ		$FFFFF708	;Word

RAM_ObjRespawnTbl_Copy			equ		$FFFFFFEC	;Word
RAM_ObjPos_GetXPos			equ		$FFFFF76E	;Word
RAM_ObjPos_GetXPos_2p			equ		$FFFFF78C	;Word

RAM_ObjPos_2pDataE_Copy			equ		$FFFFFFEE	;Word
RAM_TailsCPU_ToNextAddr			equ		$FFFFEED6	;Word

RAM_Level_BigRing_VRAM			equ		$FFFFF7BE	;Word

RAM_LevelSys_ReturnVal			equ		$FFFFEE68	;Word

RAM_Deform_EHZ_YposBgCopy		equ		$FFFFF618

; ------------------------------------------------------------------------
RAM_PLC_ROMAddress			equ		$FFFFF6E0 	;Long
RAM_VIntFrameCnt			equ		$FFFFFE0C	;Long

RAM_Hud_Time				equ		$FFFFFE22	;Long
RAM_Hud_Score				equ		$FFFFFE26	;Long
RAM_Sonic_NextScore			equ		$FFFFFFC0	;Long

RAM_Unknown_1				equ		$FFFFFE5C	;Long
RAM_Level_CopyTo2pVscrl			equ		$FFFFF61E	;Long

RAM_S1_Level_PlaneA_XPos		equ		$FFFFF700	;Long

RAM_VDPCmdFreeAddr			equ		$FFFFDCFC	;Long
RAM_Level_ColPointer			equ		$FFFFF796	;Long

RAM_LevelSys_XPos_SetStart_Backup	equ		$FFFFEEC0	;Long
RAM_LevelSys_YPos_SetStart_Backup	equ		$FFFFEEC4	;Long

RAM_LevelSys_XPos_SetStart		equ		$FFFFEEC8	;Long

RAM_ObjPos_GetObjPos			equ		$FFFFF770

RAM_RandomNumber			equ		$FFFFF636	;Long

;----------------------------------------------------------------

RAM_ObjectTable				equ		$FFFFB000	;Special
Obj_Slot_2				equ		$40
Obj_Slot_3				equ		$80
Obj_Slot_4				equ		$C0
Obj_Slot_5				equ		$100
Obj_Slot_6				equ		$140
Obj_Slot_7				equ		$180
Obj_Slot_8				equ		$1C0
Obj_Slot_9				equ		$200
Obj_Slot_10				equ		$240
Obj_Slot_11				equ		$280
Obj_Slot_12				equ		$2C0
Obj_Slot_13				equ		$300
Obj_Slot_14				equ		$340
Obj_Slot_15				equ		$380
Obj_Slot_16				equ		$3C0
Obj_Slot_17				equ		$400
Obj_Slot_18				equ		$440
Obj_Slot_19				equ		$480
Obj_Slot_20				equ		$4C0
Obj_Slot_21				equ		$500
Obj_Slot_22				equ		$540
Obj_Slot_23				equ		$580
Obj_Slot_24				equ		$5C0
Obj_Slot_25				equ		$600
Obj_Slot_26				equ		$640
Obj_Slot_27				equ		$680
Obj_Slot_28				equ		$6C0
Obj_Slot_29				equ		$700
Obj_Slot_30				equ		$740
Obj_Slot_31				equ		$780
Obj_Slot_32				equ		$7C0

RAM_Pal_1_Water_FadeTo			equ		$FFFFFA00	;Special
RAM_Pal_2_Water_FadeTo			equ		$FFFFFA20	;Special
RAM_Pal_3_Water_FadeTo			equ		$FFFFFA40	;Special
RAM_Pal_4_Water_FadeTo			equ		$FFFFFA60	;Special
RAM_Pal_1_Water				equ		$FFFFFA80	;Special
RAM_Pal_2_Water				equ		$FFFFFAA0	;Special
RAM_Pal_3_Water				equ		$FFFFFAC0	;Special
RAM_Pal_4_Water				equ		$FFFFFAE0	;Special
RAM_Pal_1				equ		$FFFFFB00	;Special
RAM_Pal_2				equ		$FFFFFB20	;Special
RAM_Pal_3				equ		$FFFFFB40	;Special
RAM_Pal_4				equ		$FFFFFB60	;Special
RAM_Pal_1_FadeTo			equ		$FFFFFB80	;Special
RAM_Pal_2_FadeTo			equ		$FFFFFBA0	;Special
RAM_Pal_3_FadeTo			equ		$FFFFFBC0	;Special
RAM_Pal_4_FadeTo			equ		$FFFFFBE0	;Special

RAM_Checksum_INIT			equ		$FFFFFFFC	;Special
RAM_ObjRespawnTbl			equ		$FFFFFC00	;Special
RAM_SprAttrTable			equ		$FFFFF800	;Special
RAM_SprAttrTable_2p			equ		$FFFFDD00	;Special

RAM_HorScrollBuffer			equ		$FFFFE000	;Special
RAM_DecompBuffer			equ		$FFFFAA00 	;Special
RAM_PLC_Buffer				equ		$FFFFF680 	;Special
RAM_VDP_CmdBuffer			equ		$FFFFDC00	;Special

RAM_MetablockTable			equ		$FFFF0000	;Special
RAM_LevelLayout				equ		$FFFF8000	;Special
RAM_SpriteTable				equ		$FFFFAC00	;Special

RAM_Sonic_InvStarPosTable		equ		$FFFFE500	;Special
RAM_Stars_InvStarPosTable		equ		$FFFFE600	;Special
RAM_Tails_InvStarPosTable		equ		$FFFFE700	;Special

RAM_WaterEffects			equ		$FFFFFE60	;Special
RAM_Demo_FramesLeft			equ		$FFFFF792	;Special

RAM_Level_ColP				equ		$FFFFD000	;Special
RAM_Level_ColS				equ		$FFFFD600	;Special
RAM_RandomTimers_Buff			equ		$FFFFFE5E	;Special

RAM_MD_SysStack				equ		$FFFFFE00	;Special
RAM_Level_Data_16			equ		$FFFF9000	;Special

RAM_LevelDeform_Buff			equ		$FFFFA800	;Special

RAM_RingSys_Buffer			equ		$FFFFE800	;Special

RAM_Level_Switches			equ		$FFFFF7E0	;Special

RAM_BlockScrollBuff			equ		$FFFFEE52	;Special
RAM_BgScrollBuff
RAM_LevelDrawBuff			equ		$FFFFEEA2	;Special

RAM_Sonic_EmeraldTypes			equ		$FFFFFE58	;Special

RAM_TailsCPU_CopiedPresses		equ		$FFFFE400	;Special

RAM_ObjPos_2pData			equ		$FFFFF780	;Special

RAM_DynLoadCues_Buffer			equ		$FFFFF7F0	;Special

RAM_SndDrv_Buff				equ		$FFFFF000	;Special

RAM_TitleScr_CheatBuff			equ		$FFFFFFE0	;Special

;----------------------------------------------------------------
RAM_Flag_WaterLevel 			equ		$FFFFF730	;Byte
RAM_Flag_WaterFlag_Copy			equ		$FFFFF64C	;Byte
RAM_Level_NoEffectsFlag			equ		$FFFFEEDC	;Byte
RAM_Flag_ControlLock			equ		$FFFFF7C8	;Byte
RAM_Flag_Sonic_TimeOver			equ		$FFFFFE1A	;Byte
RAM_Flag_HudUpd_Lives			equ		$FFFFFE1C	;Byte
RAM_Flag_HudUpd_Rings			equ		$FFFFFE1D	;Byte
RAM_Flag_HudUpd_Timer			equ		$FFFFFE1E	;Byte
RAM_Flag_HudUpd_Score			equ		$FFFFFE1F	;Byte
RAM_Flag_Sonic_Shield			equ		$FFFFFE2C	;Byte
RAM_Flag_Sonic_Invincibility		equ		$FFFFFE2D	;Byte
RAM_Flag_Sonic_Shoes			equ		$FFFFFE2E	;Byte
RAM_Flag_Sonic_Unused			equ		$FFFFFE2F	;Byte
RAM_Flag_Level_ForceReload		equ		$FFFFF720	;Byte
RAM_Flag_Unk_1				equ		$FFFFFFE2	;Byte
RAM_Flag_HudUpd_Bonus			equ		$FFFFF7D6	;Byte
RAM_Flag_VDP_Line5C			equ		$FFFFF64F	;Byte
RAM_Flag_Level_NoAnimals		equ		$FFFFF7A7	;Byte
RAM_Flag_Sonic_Shoes			equ		$FFFFFE2E	;Byte
RAM_Flag_BuildSpr_Unk			equ		$FFFFF711	;Byte
RAM_Flag_Sonic_Slide			equ		$FFFFF7C7	;Byte
RAM_Flag_Level_StopBonus		equ		$FFFFF7CD	;Byte

RAM_Flag_ResetLevel			equ		$FFFFFE02	;Word
RAM_Flag_LevelFrameTmr			equ		$FFFFFE04	;Word
RAM_Flag_DemoMode			equ		$FFFFFFF0	;Word
RAM_Flag_DebugMode			equ		$FFFFFFFA	;Word
RAM_Flag_SplitScreen			equ		$FFFFFFE8	;Word
RAM_Flag_LevelPaused			equ		$FFFFF63A	;Word
RAM_Flag_Debug_Placement		equ		$FFFFFE08	;Word
RAM_Flag_VDP_VIntFlag			equ		$FFFFF644	;Word

;----------------------------------------------------------------

RAM_ObjRAM_Sonic			equ		RAM_ObjectTable		;Special
RAM_ObjRAM_Tails			equ		RAM_ObjectTable+$40	;Special

;----------------------------------------------------------------

ModeId_Sega				equ		0
ModeId_TitleScr				equ		4
ModeId_Demo				equ		8
ModeId_Level				equ		$C
ModeId_SS				equ		$10
