; =============== S U B R O U T I N E ==========================================

VDPRegSetup:
		lea	($C00004).l,a0
		lea	($C00000).l,a1
		lea	(VDPSetupArray).l,a2
		moveq	#$12,d7

VDPRegSetup_Loop:
		move.w	(a2)+,(a0)
		dbf	d7,VDPRegSetup_Loop

		move.w	(VDPSetupArray_2).l,d0
		move.w	d0,(RAM_VDP_SavedCmd81).w
		move.w	#$8ADF,(RAM_VDPCmdForHInt).w

		moveq	#0,d0
		move.l	#$40000010,($C00004).l
		move.w	d0,(a1)			;Clear Vertical scroll
		move.w	d0,(a1)

		move.l	#$C0000000,($C00004).l
		move.w	#$3F,d7

VDPRegSetup_ClearCRAM:
		move.w	d0,(a1) ;Clear CRAM
		dbf	d7,VDPRegSetup_ClearCRAM

		clr.l	(RAM_VDP_VScroll).w
		clr.l	($FFFFF61A).w
		move.l	d1,-(sp)
		lea	($C00004).l,a5
		move.w	#$8F01,(a5)
		move.l	#$94FF93FF,(a5)
		move.w	#$9780,(a5)
		move.l	#$40000080,(a5)
		move.w	#0,($C00000).l

VDPRegSetup_DMAWait:
		move.w	(a5),d1
		btst	#1,d1
		bne.s	VDPRegSetup_DMAWait

loc_12FE:
		move.w	#$8F02,(a5)
		move.l	(sp)+,d1
		rts

; ===============================================================================
VDPSetupArray:
                dc.w $8004	;VDP: Nothing
VDPSetupArray_2:
                dc.w $8134	;VDP: DisplayEnable/VIntEnable/DMAEnable/V28
                dc.w $8230	;VDP: Field A: $C000
                dc.w $8328	;VDP: Window: $A000
                dc.w $8407	;VDP: Field B: $E000
		dc.w $857C	;VDP: Sprite: $F800
                dc.w $8600	;VDP: Null
                dc.w $8700	;VDP: Background color, Line: $0 Color: $0
                dc.w $8800	;VDP: Null
		dc.w $8900	;VDP: Null
                dc.w $8A00	;VDP: HInt value: $00 (?)
                dc.w $8B00	;VDP: Full VScroll, Full HScroll
                dc.w $8C81	;VDP: "H40"
		dc.w $8D3F	;VDP: HScroll: $FC00
                dc.w $8E00	;VDP: Nothing
                dc.w $8F02	;VDP: Auto increment of $02
                dc.w $9001	;VDP: V32 Cell, H64 Cell
		dc.w $9100	;VDP: Window Layer: $0 cells from left
                dc.w $9200	;VDP: Window Layer: $0 cells from bottom
VDPSetupArray_End: