TitleScreen:
		move.b	#Snd_Special_StopSng,d0
		bsr.w	PlaySound_Special
		bsr.w	ClearPLC
		bsr.w	Pal_FadeFrom
		move	#$2700,sr
		bsr.w	SoundDriverLoad
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$9001,(a6)
		move.w	#$9200,(a6)
		move.w	#$8B03,(a6)
		move.w	#$8720,(a6)
		clr.b	(RAM_FillWaterPalScr).w
		move.w	#$8C81,(a6)
		bsr.w	ClearScreen

		lea	(RAM_SpriteTable).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_3230:
		move.l	d0,(a1)+
		dbf	d1,loc_3230
		lea	(RAM_ObjectTable).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_3240:
		move.l	d0,(a1)+
		dbf	d1,loc_3240
		lea	(RAM_S1_Level_PlaneA_XPos).w,a1
		moveq	#0,d0
		move.w	#$3F,d1	; '?'

loc_3250:
		move.l	d0,(a1)+
		dbf	d1,loc_3250
		lea	(RAM_LevelSys_Buff).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_3260:
		move.l	d0,(a1)+
		dbf	d1,loc_3260
		lea	(RAM_Pal_1_FadeTo).w,a1
		moveq	#0,d0
		move.w	#$1F,d1

loc_3270:
		move.l	d0,(a1)+
		dbf	d1,loc_3270

		moveq	#3,d0
		bsr.w	PalLoad1
		bsr.w	Pal_FadeTo

		move	#$2700,sr

		move.l	#$40000000,($C00004).l
		lea	(Nem_Title).l,a0
		bsr.w	NemDec
		move.l	#$40000001,($C00004).l
		lea	(Nem_TitleSonicTails).l,a0
		bsr.w	NemDec

		lea	($C00000).l,a6
		move.l	#$50000003,4(a6)
		lea	(Art_Text).l,a5
		move.w	#$28F,d1

loc_32C4:
		move.w	(a5)+,(a6)
		dbf	d1,loc_32C4
		nop
		move.b	#0,(RAM_Level_LamppostCntr).w
		move.w	#0,(RAM_Flag_Debug_Placement).w
		move.w	#0,(RAM_Flag_DemoMode).w
		move.w	#0,($FFFFFFEA).w
		move.w	#0,(RAM_Level_CurrentZone).w
		move.w	#0,(RAM_PalCyc_Timer2).w

		bsr.w	Pal_FadeFrom
		move	#$2700,sr
		lea	(RAM_MetablockTable).l,a1
		lea	(Eni_TitleMap).l,a0
		move.w	#0,d0
		bsr.w	EniDec
		lea	(RAM_MetablockTable).l,a1
		move.l	#$40000003,d0
		moveq	#$27,d1	; '''
		moveq	#$1B,d2
		bsr.w	LoadMaps
		lea	(RAM_MetablockTable).l,a1
		lea	(Eni_TitleBg1).l,a0
		move.w	#0,d0

loc_3330:
		bsr.w	EniDec
		lea	(RAM_MetablockTable).l,a1
		move.l	#$60000003,d0
		moveq	#$1F,d1
		moveq	#$1B,d2
		bsr.w	LoadMaps
		lea	(RAM_MetablockTable).l,a1
		lea	(Eni_TitleBg2).l,a0
		move.w	#0,d0
		bsr.w	EniDec
		
		lea	(RAM_MetablockTable).l,a1
		move.l	#$60400003,d0
		moveq	#$1F,d1
		moveq	#$1B,d2
		bsr.w	LoadMaps
		moveq	#1,d0
		bsr.w	PalLoad1
		move.b	#$8A,d0
		bsr.w	PlaySound_Special
		move.b	#0,(RAM_Flag_DebugMode).w
		move.w	#0,(RAM_Flag_SplitScreen).w
		move.w	#$178,(RAM_DemoTimeLeft).w

		lea	(RAM_ObjectTable+$80).w,a1
		moveq	#0,d0
		move.w	#$F,d1

loc_339A:
		move.l	d0,(a1)+
		dbf	d1,loc_339A

		move.b	#$E,(RAM_ObjectTable+$40).w
		move.b	#$E,(RAM_ObjectTable+$80).w
		move.b	#1,(RAM_ObjectTable+$80+$1A).w
		jsr	ObjectsLoad
		jsr	BuildSprites
		moveq	#0,d0
		bsr.w	LoadPLC2
		move.w	#0,(RAM_SndDrv_PlaySnd_2).w
		move.w	#0,($FFFFFFE6).w
		move.w	#$300,(RAM_Level_CurrentZone).w
		move.w	#4,(RAM_Sonic_StaticsRecBuffer).w
		move.w	#0,(RAM_Sonic_InvStarPosTable).w

		move.w	(RAM_VDP_Command_1).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		bsr.w	Pal_FadeTo

TitleScreen_Loop:
		move.b	#4,(RAM_VIntCount).w
		bsr.w	DelayProgram

		jsr	ObjectsLoad
		bsr.w	Deform_TitleScreen
		jsr	BuildSprites
		bsr.w	RunPLC

		tst.b	(RAM_MD_SysRegion).w
		bpl.s	Title_RegionJ
		lea	(LvlSelCode_US).l,a0
		bra.s	LevelSelectCheat
; ===============================================================================
Title_RegionJ:
		lea	(LvlSelCode_J).l,a0

LevelSelectCheat:
		move.w	(RAM_SndDrv_PlaySnd_2).w,d0
		adda.w	d0,a0
		move.b	(RAM_Control_1_Press).w,d0
		andi.b	#$F,d0
		cmp.b	(a0),d0
		bne.s	Title_Cheat_NoMatch
		addq.w	#1,(RAM_SndDrv_PlaySnd_2).w
		tst.b	d0
		bne.s	Title_Cheat_CountC
		lea	(RAM_TitleScr_CheatBuff).w,a0
		move.w	(RAM_TitleScr_CheatBuff+$6).w,d1
		lsr.w	#1,d1
		andi.w	#3,d1
		beq.s	Title_Cheat_PlayRing
		tst.b	(RAM_MD_SysRegion).w
		bpl.s	Title_Cheat_PlayRing
		moveq	#1,d1
		move.b	d1,1(a0,d1.w)

Title_Cheat_PlayRing:
		move.b	#1,(a0,d1.w)
		move.b	#$B5,d0
		bsr.w	PlaySound_Special
		bra.s	Title_Cheat_CountC

Title_Cheat_NoMatch:
		tst.b	d0
		beq.s	Title_Cheat_CountC
		cmpi.w	#9,(RAM_SndDrv_PlaySnd_2).w
		beq.s	Title_Cheat_CountC
		move.w	#0,(RAM_SndDrv_PlaySnd_2).w

Title_Cheat_CountC:
		move.b	(RAM_Control_1_Press).w,d0
		andi.b	#$20,d0
		beq.s	Title_Cheat_NoC
		addq.w	#1,(RAM_TitleScr_CheatBuff+$6).w

Title_Cheat_NoC:
		tst.w	(RAM_DemoTimeLeft).w
		beq.w	Demo
		andi.b	#$80,(RAM_Control_1_Press).w
		beq.w	TitleScreen_Loop
; ===============================================================================

Title_CheckLvlSel:
		tst.b	(RAM_TitleScr_CheatBuff).w
		beq.w	PlayLevel
		
; ================================================================================
; Level Select (Called from TitleScreen)
; ================================================================================

LevelSelect_Init:
		moveq	#2,d0
		bsr.w	PalLoad2

		lea	(RAM_HorScrollBuffer).w,a1
		moveq	#0,d0
		move.w	#$DF,d1

@ClearScroll:
		move.l	d0,(a1)+
		dbf	d1,@ClearScroll
		move.l	d0,(RAM_VDP_VScroll).w

		move	#$2700,sr

		lea	($C00000).l,a6
		move.l	#$60000003,($C00004).l
		move.w	#$3FF,d1
@ClearVRAM:
		move.l	d0,(a6)
		dbf	d1,@ClearVRAM

		bsr.w	LevelSelect_TextLoad

LevelSelect_Loop:
		move.b	#4,(RAM_VIntCount).w
		bsr.w	DelayProgram

		bsr.w	LevelSelect_Controls
		bsr.w	RunPLC
		tst.l	(RAM_PLC_Buffer).w
		bne.s	LevelSelect_Loop
		andi.b	#$F0,(RAM_Control_1_Press).w
		beq.s	LevelSelect_Loop
		move.w	#0,(RAM_Flag_SplitScreen).w
		btst	#4,(RAM_Control_1_Hold).w
		beq.s	loc_3516
		move.w	#1,(RAM_Flag_SplitScreen).w

loc_3516:
		move.w	(RAM_LevSel_SelItem).w,d0
		cmpi.w	#$14,d0
		bne.s	loc_3570
		move.w	(RAM_LevSel_SelSnd).w,d0
		addi.w	#$80,d0
		tst.b	(RAM_SndDrv_PlaySnd).w
		beq.s	loc_353A
		cmpi.w	#$9F,d0
		beq.s	loc_354C
		cmpi.w	#$9E,d0
		beq.s	loc_355A

loc_353A:
		cmpi.w	#$94,d0
		bcs.s	loc_3546
		cmpi.w	#$A0,d0
		bcs.s	LevelSelect_Loop

loc_3546:
		bsr.w	PlaySound_Special
		bra.s	LevelSelect_Loop
; ===============================================================================

loc_354C:
		move.b	#$18,(RAM_GameMode).w			;Leftover from S1
		move.w	#$600,(RAM_Level_CurrentZone).w
		rts
; ===============================================================================
loc_355A:
		move.b	#$1C,(RAM_GameMode).w			;Leftover from S1
		move.b	#$91,d0
		bsr.w	PlaySound_Special
		move.w	#0,(RAM_S1_CreditsID).w
		rts
; ==============================================================================

loc_3570:
		add.w	d0,d0
		move.w	LevelSelect_LevelOrder(pc,d0.w),d0
		bmi.w	LevelSelect_Loop
		cmpi.w	#$700,d0
		bne.s	LevelSelect_Level
		move.b	#ModeId_SS,(RAM_GameMode).w
		clr.w	(RAM_Level_CurrentZone).w
		move.b	#3,(RAM_Sonic_Lives).w
		moveq	#0,d0
		move.w	d0,(RAM_Sonic_CurrentRings).w
		move.l	d0,(RAM_Hud_Time).w
		move.l	d0,(RAM_Hud_Score).w
		move.l	#$1388,(RAM_Sonic_NextScore).w
		rts
; ===============================================================================
LevelSelect_LevelOrder:
		dc.w	0,    1,    2  ; 0
		dc.w  $200, $201, $202	; 3
		dc.w  $400, $401, $402	; 6
		dc.w  $100, $101, $102	; 9
		dc.w  $300, $301, $302	; 12
		dc.w  $500, $501, $103	; 15
		dc.w  $502, $700,$8000	; 18
; ===============================================================================

LevelSelect_Level:
		andi.w	#$3FFF,d0			;Limit to $3FFF
		move.w	d0,(RAM_Level_CurrentZone).w

PlayLevel:
		move.b	#ModeId_Level,(RAM_GameMode).w
		move.b	#3,(RAM_Sonic_Lives).w
		moveq	#0,d0
		move.w	d0,(RAM_Sonic_CurrentRings).w
		move.l	d0,(RAM_Hud_Time).w
		move.l	d0,(RAM_Hud_Score).w
		move.b	d0,(RAM_SpecialStg_Level).w
		move.b	d0,(RAM_Sonic_Emeralds).w
		move.l	d0,(RAM_Sonic_Emeralds+$1).w
		move.l	d0,(RAM_Unknown_1).w
		move.b	d0,(RAM_Sonic_Continues).w
		move.l	#$1388,(RAM_Sonic_NextScore).w
		move.b	#$E0,d0
		bsr.w	PlaySound_Special
		rts

; ===============================================================================
LvlSelCode_J:	dc.b   1,  2,  2,  2,  2,  1,  0,$FF
LvlSelCode_US:	dc.b   1,  2,  2,  2,  2,  1,  0,$FF
; ===============================================================================
