; =============== S U B R O U T I N E ==========================================

Pal_FadeTo:
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w

Pal_FadeTo2:
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		moveq	#0,d1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_2162:
		move.w	d1,(a0)+
		dbf	d0,loc_2162
		move.w	#$15,d4

loc_216C:
		move.b	#$12,(RAM_VIntCount).w
		bsr.w	DelayProgram
		bsr.s	Pal_FadeIn
		bsr.w	RunPLC
		dbf	d4,loc_216C
		rts
; End of function Pal_FadeTo


; =============== S U B R O U T I N E ==========================================

Pal_FadeIn:
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		lea	(RAM_Pal_1_FadeTo).w,a1
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_2198:
		bsr.s	Pal_AddColor
		dbf	d0,loc_2198
		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	locret_21C0
		moveq	#0,d0
		lea	(RAM_Pal_1_Water).w,a0
		lea	(RAM_Pal_1_Water_FadeTo).w,a1
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_21BA:
		bsr.s	Pal_AddColor
		dbf	d0,loc_21BA

locret_21C0:
		rts

; =============== S U B R O U T I N E ==========================================


Pal_AddColor:				; CODE XREF: Pal_FadeIn:loc_2198p
					; Pal_FadeIn:loc_21BAp
		move.w	(a1)+,d2
		move.w	(a0),d3
		cmp.w	d2,d3
		beq.s	Pal_NoAdd
		move.w	d3,d1
		addi.w	#$200,d1
		cmp.w	d2,d1
		bhi.s	Pal_AddGreen
		move.w	d1,(a0)+
		rts
; ===============================================================================

Pal_AddGreen:				; CODE XREF: Pal_AddColor+10j
		move.w	d3,d1
		addi.w	#$20,d1	; ' '
		cmp.w	d2,d1
		bhi.s	Pal_AddRed
		move.w	d1,(a0)+
		rts
; ===============================================================================

Pal_AddRed:				; CODE XREF: Pal_AddColor+1Ej
		addq.w	#2,(a0)+
		rts
; ===============================================================================

Pal_NoAdd:				; CODE XREF: Pal_AddColor+6j
		addq.w	#2,a0
		rts

; =============== S U B R O U T I N E ==========================================


Pal_FadeFrom:
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w
		move.w	#$15,d4

loc_21F8:
		move.b	#$12,(RAM_VIntCount).w
		bsr.w	DelayProgram
		bsr.s	Pal_FadeOut
		bsr.w	RunPLC
		dbf	d4,loc_21F8
		rts

; =============== S U B R O U T I N E ==========================================


Pal_FadeOut:
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_221E:
		bsr.s	Pal_DecColor
		dbf	d0,loc_221E
		moveq	#0,d0
		lea	(RAM_Pal_1_Water).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_2234:
		bsr.s	Pal_DecColor
		dbf	d0,loc_2234
		rts


; =============== S U B R O U T I N E ==========================================


Pal_DecColor:
		move.w	(a0),d2
		beq.s	Pal_NoDec
		move.w	d2,d1
		andi.w	#$E,d1		;Get color green
		beq.s	Pal_DecGreen    ;Branch if equal
		subq.w	#2,(a0)+        ;Subtract $2 from red
		rts
; ===============================================================================

Pal_DecGreen:
		move.w	d2,d1
		andi.w	#$E0,d1		;Get color blue
		beq.s	Pal_DecBlue	;Branch if equal
		subi.w	#$20,(a0)+	;Subtract $2 from green
		rts
; ===============================================================================

Pal_DecBlue:
		move.w	d2,d1
		andi.w	#$E00,d1	;Get color red
		beq.s	Pal_NoDec	;Branch if equal
		subi.w	#$200,(a0)+	;Subtract $2 from blue
		rts
; ===============================================================================

Pal_NoDec:
		addq.w	#2,a0
		rts

; =============== S U B R O U T I N E ==========================================


Pal_MakeWhite:
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w ; '?'
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		move.w	#$EEE,d1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_2286:
		move.w	d1,(a0)+
		dbf	d0,loc_2286
		move.w	#$15,d4

loc_2290:
		move.b	#$12,(RAM_VIntCount).w
		bsr.w	DelayProgram
		bsr.s	Pal_WhiteToBlack
		bsr.w	RunPLC
		dbf	d4,loc_2290
		rts


; =============== S U B R O U T I N E ==========================================


Pal_WhiteToBlack:
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		lea	(RAM_Pal_1_FadeTo).w,a1
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_22BC:
		bsr.s	Pal_DecColor2
		dbf	d0,loc_22BC
		tst.b	(RAM_Flag_WaterLevel).w
		beq.s	locret_22E4
		moveq	#0,d0
		lea	(RAM_Pal_1_Water).w,a0
		lea	(RAM_Pal_1_Water_FadeTo).w,a1
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_22DE:
		bsr.s	Pal_DecColor2
		dbf	d0,loc_22DE

locret_22E4:
		rts


; =============== S U B R O U T I N E ==========================================


Pal_DecColor2:
		move.w	(a1)+,d2
		move.w	(a0),d3
		cmp.w	d2,d3
		beq.s	loc_2312
		move.w	d3,d1
		subi.w	#$200,d1
		bcs.s	loc_22FE
		cmp.w	d2,d1
		bcs.s	loc_22FE
		move.w	d1,(a0)+
		rts
; ===============================================================================

loc_22FE:
		move.w	d3,d1
		subi.w	#$20,d1
		bcs.s	loc_230E
		cmp.w	d2,d1
		bcs.s	loc_230E
		move.w	d1,(a0)+
		rts
; ===============================================================================

loc_230E:
		subq.w	#2,(a0)+
		rts
; ===============================================================================

loc_2312:
		addq.w	#2,a0
		rts


; =============== S U B R O U T I N E ==========================================


Pal_MakeFlash:
		move.w	#$3F,(RAM_Pal_FadeToCtrl_PalStart).w ; '?'
		move.w	#$15,d4

loc_2320:
		move.b	#$12,(RAM_VIntCount).w
		bsr.w	DelayProgram
		bsr.s	Pal_ToWhite
		bsr.w	RunPLC
		dbf	d4,loc_2320
		rts


; =============== S U B R O U T I N E ==========================================


Pal_ToWhite:
		moveq	#0,d0
		lea	(RAM_Pal_1).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_2346:
		bsr.s	Pal_AddColor2
		dbf	d0,loc_2346
		moveq	#0,d0

loc_234E:
		lea	(RAM_Pal_1_Water).w,a0
		move.b	(RAM_Pal_FadeToCtrl_PalStart).w,d0
		adda.w	d0,a0
		move.b	(RAM_Pal_FadeToCtrl_PalLength).w,d0

loc_235C:
		bsr.s	Pal_AddColor2
		dbf	d0,loc_235C
		rts


; =============== S U B R O U T I N E ==========================================


Pal_AddColor2:
		move.w	(a0),d2
		cmpi.w	#$EEE,d2
		beq.s	loc_23A0
		move.w	d2,d1
		andi.w	#$E,d1
		cmpi.w	#$E,d1
		beq.s	loc_237C
		addq.w	#2,(a0)+
		rts
; ===============================================================================

loc_237C:
		move.w	d2,d1
		andi.w	#$E0,d1
		cmpi.w	#$E0,d1
		beq.s	loc_238E

loc_2388:
		addi.w	#$20,(a0)+
		rts
; ===============================================================================

loc_238E:
		move.w	d2,d1
		andi.w	#$E00,d1
		cmpi.w	#$E00,d1
		beq.s	loc_23A0
		addi.w	#$200,(a0)+
		rts
; ===============================================================================

loc_23A0:
		addq.w	#2,a0
		rts
